]> git.ipfire.org Git - thirdparty/git.git/blob - git-merge-one-file.sh
Merge git://repo.or.cz/git-gui
[thirdparty/git.git] / git-merge-one-file.sh
1 #!/bin/sh
2 #
3 # Copyright (c) Linus Torvalds, 2005
4 #
5 # This is the git per-file merge script, called with
6 #
7 # $1 - original file SHA1 (or empty)
8 # $2 - file in branch1 SHA1 (or empty)
9 # $3 - file in branch2 SHA1 (or empty)
10 # $4 - pathname in repository
11 # $5 - original file mode (or empty)
12 # $6 - file in branch1 mode (or empty)
13 # $7 - file in branch2 mode (or empty)
14 #
15 # Handle some trivial cases.. The _really_ trivial cases have
16 # been handled already by git read-tree, but that one doesn't
17 # do any merges that might change the tree layout.
18
19 case "${1:-.}${2:-.}${3:-.}" in
20 #
21 # Deleted in both or deleted in one and unchanged in the other
22 #
23 "$1.." | "$1.$1" | "$1$1.")
24 if [ "$2" ]; then
25 echo "Removing $4"
26 else
27 # read-tree checked that index matches HEAD already,
28 # so we know we do not have this path tracked.
29 # there may be an unrelated working tree file here,
30 # which we should just leave unmolested. Make sure
31 # we do not have it in the index, though.
32 exec git update-index --remove -- "$4"
33 fi
34 if test -f "$4"; then
35 rm -f -- "$4" &&
36 rmdir -p "$(expr "z$4" : 'z\(.*\)/')" 2>/dev/null || :
37 fi &&
38 exec git update-index --remove -- "$4"
39 ;;
40
41 #
42 # Added in one.
43 #
44 ".$2.")
45 # the other side did not add and we added so there is nothing
46 # to be done, except making the path merged.
47 exec git update-index --add --cacheinfo "$6" "$2" "$4"
48 ;;
49 "..$3")
50 echo "Adding $4"
51 test -f "$4" || {
52 echo "ERROR: untracked $4 is overwritten by the merge."
53 exit 1
54 }
55 git update-index --add --cacheinfo "$7" "$3" "$4" &&
56 exec git checkout-index -u -f -- "$4"
57 ;;
58
59 #
60 # Added in both, identically (check for same permissions).
61 #
62 ".$3$2")
63 if [ "$6" != "$7" ]; then
64 echo "ERROR: File $4 added identically in both branches,"
65 echo "ERROR: but permissions conflict $6->$7."
66 exit 1
67 fi
68 echo "Adding $4"
69 git update-index --add --cacheinfo "$6" "$2" "$4" &&
70 exec git checkout-index -u -f -- "$4"
71 ;;
72
73 #
74 # Modified in both, but differently.
75 #
76 "$1$2$3" | ".$2$3")
77
78 case ",$6,$7," in
79 *,120000,*)
80 echo "ERROR: $4: Not merging symbolic link changes."
81 exit 1
82 ;;
83 esac
84
85 src2=`git-unpack-file $3`
86 case "$1" in
87 '')
88 echo "Added $4 in both, but differently."
89 # This extracts OUR file in $orig, and uses git apply to
90 # remove lines that are unique to ours.
91 orig=`git-unpack-file $2`
92 sz0=`wc -c <"$orig"`
93 diff -u -La/$orig -Lb/$orig $orig $src2 | git apply --no-add
94 sz1=`wc -c <"$orig"`
95
96 # If we do not have enough common material, it is not
97 # worth trying two-file merge using common subsections.
98 expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
99 ;;
100 *)
101 echo "Auto-merging $4"
102 orig=`git-unpack-file $1`
103 ;;
104 esac
105
106 # Be careful for funny filename such as "-L" in "$4", which
107 # would confuse "merge" greatly.
108 src1=`git-unpack-file $2`
109 git merge-file "$src1" "$orig" "$src2"
110 ret=$?
111
112 # Create the working tree file, using "our tree" version from the
113 # index, and then store the result of the merge.
114 git checkout-index -f --stage=2 -- "$4" && cat "$src1" >"$4"
115 rm -f -- "$orig" "$src1" "$src2"
116
117 if [ "$6" != "$7" ]; then
118 echo "ERROR: Permissions conflict: $5->$6,$7."
119 ret=1
120 fi
121 if [ "$1" = '' ]; then
122 ret=1
123 fi
124
125 if [ $ret -ne 0 ]; then
126 echo "ERROR: Merge conflict in $4"
127 exit 1
128 fi
129 exec git update-index -- "$4"
130 ;;
131
132 *)
133 echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
134 ;;
135 esac
136 exit 1